Overview | Package | Class | Tree | Deprecated | Index | Help
| Compoze Software, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.compoze.collab
Interface IProvider

public interface IProvider

Provides the abstract superclass for all collaboration service providers.

Method Summary
`void` | `addClassMapping(Key key, java.lang.String sSource, ItemClass target)` Programatically adds a class mapping to the default schema for the provider.
`java.lang.String` | `getBackendName(java.util.Locale locale)` Gets the name of the back-end data store or collaboration system.
`java.lang.String` | `getInternalName()` Gets an internal name for the provider (must be unique among all registered providers).
`java.lang.String` | `getLegalTrademarks(java.util.Locale locale)` Gets the legal information regarding the provider and its terms of legal use.
`java.util.List` | `getLocales()` Gets the available locales for the provider.
`java.lang.String` | `getLoggerName()` Gets the name of the logger for the provider.
`java.lang.String` | `getName(java.util.Locale locale)` Gets a descriptive name for the provider.
`java.lang.String` | `getProviderProperty(java.lang.String key)` Get a provider configuration property.
`java.util.List` | `getRequiredSessionProperties(java.util.Map props)` Gets the required properties given that the specified properties have already been supplied.
`java.lang.String` | `getResourceBase()` Gets the base name of the resource bundle.
`java.util.List` | `getSessionProperties(java.util.Map props)` Gets the required and optional session properties given that the specified properties have already been supplied.
`SessionProperty` | `getSessionProperty(java.lang.String sInternalName)` Gets a session property by its internal name.
`java.lang.String` | `getVendorName(java.util.Locale locale)` Gets the company that authored the provider.
`void` | `setProviderProperty(java.lang.String key, java.lang.String value)` Set a provider configuration property.
`boolean` | `supportsCacheDependencies()` Determines if this provider supports cache dependency checking.
`boolean` | `supportsSchema(java.lang.String sSchema)` Determines if this provider supports a given schema.
`java.lang.String` | `toString()` Creates a string representation of the provider.
`void` | `validateSessionProperties(com.compoze.collab.spi.Context ctx, java.util.Map props)` Validates session properties for well-formedness and throws an exception if there is a problem.

Method Detail

### getLocales

    public java.util.List getLocales()

  Gets the available locales for the provider.

  Returns:
    a `List` of the available locales

### getSessionProperty

    public SessionProperty getSessionProperty(java.lang.String sInternalName)

  Gets a session property by its internal name.

  Parameters:
    `sInternalName` - the internal name
  Returns:
    the session property, or `null` if no property exists with this internal name

### getSessionProperties

    public java.util.List getSessionProperties(java.util.Map props)
                                        throws CollaborationException

  Gets the required and optional session properties given that the specified properties have already been supplied.

  Parameters:
    `props` - the properties that have already been supplied, or `null` for no pre-supplied properties
  Returns:
    the `List` of required and optional `SessionProperty` objects, or `null` if all properties have been supplied
  Throws:
    `CollaborationException` - if some of the supplied properties were invalid

### getRequiredSessionProperties

    public java.util.List getRequiredSessionProperties(java.util.Map props)
                                                throws CollaborationException

  Gets the required properties given that the specified properties have already been supplied.

  Parameters:
    `props` - the properties that have already been supplied, or `null` for no pre-supplied properties
  Returns:
    the `List` of required `SessionProperty` objects in order to proceed, or `null` if no properties are required
  Throws:
    `CollaborationException` - if some of the supplied properties were invalid

### validateSessionProperties

    public void validateSessionProperties(com.compoze.collab.spi.Context ctx,
                                          java.util.Map props)
                                   throws CollaborationException

  Validates session properties for well-formedness and throws an exception if there is a problem. This method checks for existence of properties then calls the provider implementation to check for well-formedness.

  Parameters:
    `ctx` - the provider context
    `props` - the properties to validate
  Throws:
    `CollaborationException` - if there is a problem with the properties

### getVendorName

    public java.lang.String getVendorName(java.util.Locale locale)

  Gets the company that authored the provider. Subclasses should override this implementation as the default is a string indicating that the company is not available.

  Parameters:
    `locale` - the locale
  Returns:
    the company name

### getInternalName

    public java.lang.String getInternalName()

  Gets an internal name for the provider (must be unique among all registered providers). By convention, internal names should be one word made of alphanumeric lowercase characters with underbars and no spaces.

  Returns:
    the internal name

### getLegalTrademarks

    public java.lang.String getLegalTrademarks(java.util.Locale locale)

  Gets the legal information regarding the provider and its terms of legal use. Subclasses should override this implementation as the default is a string indicating that the legal trademarks are not available.

  Parameters:
    `locale` - the locale

### getName

    public java.lang.String getName(java.util.Locale locale)

  Gets a descriptive name for the provider. This descriptive name is not used to identify the provider in any way- it is provided for informational purposes.

  Parameters:
    `locale` - the locale
  Returns:
    the descriptive name

### getBackendName

    public java.lang.String getBackendName(java.util.Locale locale)

  Gets the name of the back-end data store or collaboration system.

  Parameters:
    `locale` - the locale
  Returns:
    the back-end name

### getLoggerName

    public java.lang.String getLoggerName()

  Gets the name of the logger for the provider.

  Returns:
    the logger name

### getResourceBase

    public java.lang.String getResourceBase()

  Gets the base name of the resource bundle.

  Returns:
    the resource base name

### supportsSchema

    public boolean supportsSchema(java.lang.String sSchema)

  Determines if this provider supports a given schema.

  Parameters:
    `sSchema` - the internal name of the schema (not `null`)
  Returns:
    `true` if this provider supports the specified schema

### supportsCacheDependencies

    public boolean supportsCacheDependencies()

  Determines if this provider supports cache dependency checking.

  Returns:
    `true` if the provider supports cache dependency checking

### toString

    public java.lang.String toString()

  Creates a string representation of the provider.

  Returns:
    the string representation

### setProviderProperty

    public void setProviderProperty(java.lang.String key,
                                    java.lang.String value)

  Set a provider configuration property.

  Parameters:
    `key` - property key
    `value` - property value

### getProviderProperty

    public java.lang.String getProviderProperty(java.lang.String key)

  Get a provider configuration property.

  Parameters:
    `key` - property key
  Returns:
    the property value or `null` if the property is not set

### addClassMapping

    public void addClassMapping(Key key,
                                java.lang.String sSource,
                                ItemClass target)

  Programatically adds a class mapping to the default schema for the provider.

  Parameters:
    `key` - the provider key to perform the mapping
    `sSource` - the provider specific value to map
    `target` - the target item class (MUST have an internal name)

Overview | Package | Class | Tree | Deprecated | Index | Help
| Compoze Software, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright ©1999-2003 Compoze Software, Inc. All rights reserved.